function varargout = acquisition_v2(varargin)
% ACQUISITION_V2 MATLAB code for acquisition_v2.fig
%      ACQUISITION_V2, by itself, creates a new ACQUISITION_V2 or raises the existing
%      singleton*.
%
%      H = ACQUISITION_V2 returns the handle to a new ACQUISITION_V2 or the handle to
%      the existing singleton*.
%
%      ACQUISITION_V2('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ACQUISITION_V2.M with the given input arguments.
%
%      ACQUISITION_V2('Property','Value',...) creates a new ACQUISITION_V2 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before acquisition_v2_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to acquisition_v2_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help acquisition_v2

% Last Modified by GUIDE v2.5 14-Jul-2015 11:51:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @acquisition_v2_OpeningFcn, ...
                   'gui_OutputFcn',  @acquisition_v2_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before acquisition_v2 is made visible.
function acquisition_v2_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to acquisition_v2 (see VARARGIN)

% Choose default command line output for acquisition_v2
handles.output = hObject;

% Update handles structure
vidobj1 = videoinput('winvideo', 1,'RGB24_1280x1024');
handles.vidobj1=vidobj1;
vidobj2 = videoinput('winvideo', 2,'RGB24_1280x1024');
handles.vidobj2=vidobj2;
guidata(hObject, handles);

% UIWAIT makes acquisition_v2 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = acquisition_v2_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in TestCameraA.
function TestCameraA_Callback(hObject, eventdata, handles)
% hObject    handle to TestCameraA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
frame1=getsnapshot(handles.vidobj1);
axes(handles.axes1)
imshow(frame1)


% --- Executes on button press in TestCameraB.
function TestCameraB_Callback(hObject, eventdata, handles)
% hObject    handle to TestCameraB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
frame2=getsnapshot(handles.vidobj2);
axes(handles.axes2)
imshow(frame2)


% --- Executes on button press in AcquireButton.
function AcquireButton_Callback(hObject, eventdata, handles)
% hObject    handle to AcquireButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
totalFrames=inf; framesToLog=1; grabInterval=1; frameRate=15;
set(handles.vidobj1, 'FramesPerTrigger', framesToLog);
set(handles.vidobj2, 'FramesPerTrigger', framesToLog);
src1 = getselectedsource(handles.vidobj1);
set(src1, 'FrameRate', num2str(frameRate));
src1.Exposure = handles.ExposureA;
src2 = getselectedsource(handles.vidobj2);
set(src2, 'FrameRate', num2str(frameRate));
src2.Exposure = handles.ExposureB;
for ii=1:totalFrames
    %Start the webcameras
    start(handles.vidobj1);
    wait(handles.vidobj1,inf); 
    start(handles.vidobj2);
    wait(handles.vidobj2,inf); 
    %Acuire frames from both cameras
    framesA = getdata(handles.vidobj1);
    framesB = getdata(handles.vidobj2);
    framesA(:,:,2:3)=[];
    framesB(:,:,2:3)=[];
    handles.framesA=framesA;
    handles.framesB=framesB;
    %Plot data and write file Camera A
    imagesc(double(framesA),'Parent',handles.axes1); 
    colormap('jet')
    filename1 = sprintf('A%i.png',ii);
    imwrite(framesA,filename1,'png');    
    %Plot data and write file Camera B    
    imagesc(double(framesB),'Parent',handles.axes2); 
    colormap('jet')
    colorbar('location','EastOutside')
    filename2 = sprintf('B%i.png',ii);
    imwrite(framesB,filename2,'png');
end
guidata(hObject,handles);


% --- Executes on button press in StopButton.
function StopButton_Callback(hObject, eventdata, handles)
% hObject    handle to StopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in TestAllButton.
function TestAllButton_Callback(hObject, eventdata, handles)
% hObject    handle to TestAllButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
totalFrames=1; framesToLog=1; frameRate=15;
set(handles.vidobj1, 'FramesPerTrigger', framesToLog);
set(handles.vidobj2, 'FramesPerTrigger', framesToLog);
src1 = getselectedsource(handles.vidobj1);
set(src1, 'FrameRate', num2str(frameRate));
src1.Exposure = handles.ExposureA;
src2 = getselectedsource(handles.vidobj2);
set(src2, 'FrameRate', num2str(frameRate));
src2.Exposure = handles.ExposureB;
for ii=1:totalFrames
    %Start the webcameras
    start(handles.vidobj1);
    wait(handles.vidobj1,inf); 
    start(handles.vidobj2);
    wait(handles.vidobj2,inf);     
    %Acuire frames from both cameras
    framesA = getdata(handles.vidobj1);
    framesB = getdata(handles.vidobj2);
    framesA(:,:,2:3)=[];
    framesB(:,:,2:3)=[];
    %Plot all test figures
    imagesc(double(framesA),'Parent',handles.axes1); 
    colormap('jet')
    colorbar('location','EastOutside')
    imagesc(double(framesB),'Parent',handles.axes2); 
    colormap('jet')
    colorbar('location','EastOutside')
end
guidata(hObject,handles);


% --- Executes on button press in VignetteButton.
function VignetteButton_Callback(hObject, eventdata, handles)
% hObject    handle to VignetteButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vigFrames=1; framesToLog=1; grabInterval=1; frameRate=15;
set(handles.vidobj1, 'FramesPerTrigger', framesToLog);
set(handles.vidobj2, 'FramesPerTrigger', framesToLog);
src1 = getselectedsource(handles.vidobj1);
set(src1, 'FrameRate', num2str(frameRate));
src1.Exposure = handles.ExposureA;
src2 = getselectedsource(handles.vidobj2);
set(src2, 'FrameRate', num2str(frameRate));
src2.Exposure = handles.ExposureB;

for ii=1:vigFrames
    start(handles.vidobj1);
    wait(handles.vidobj1,inf); 
    start(handles.vidobj2);
    wait(handles.vidobj2,inf); 
    vigA = getdata(handles.vidobj1);
    vigB = getdata(handles.vidobj2);
    vigA(:,:,2:3)=[];
    vigB(:,:,2:3)=[];
    % ADD IN IF ELSE IF STUFF HERE TO UNABLE MULTIPLE VIGNETTING FILES
    imagesc(double(vigA),'Parent',handles.axes1); colormap('jet'); 
    imagesc(double(vigB),'Parent',handles.axes2); colormap('jet');
    %Vignette File Existence
    vig_ex_1=exist('vig_cameraA_1.png','file');
    vig_ex_2=exist('vig_cameraA_2.png','file');
    vig_ex_3=exist('vig_cameraA_3.png','file');
    vig_ex_4=exist('vig_cameraA_4.png','file');
    vig_ex_5=exist('vig_cameraA_5.png','file');
    %Vignette File Creation - NOTE MAXIMUM OF FIVE PER DIRECTORY
    if vig_ex_1==0
        filename1 = sprintf('vig_cameraA_1.png');
        imwrite(vigA,filename1,'png');
        filename2 = sprintf('vig_cameraB_1.png');
        imwrite(vigB,filename2,'png');
    elseif vig_ex_2==0
        filename1 = sprintf('vig_cameraA_2.png');
        imwrite(vigA,filename1,'png');
        filename2 = sprintf('vig_cameraB_2.png');
        imwrite(vigB,filename2,'png');
    elseif vig_ex_3==0
        filename1 = sprintf('vig_cameraA_3.png');
        imwrite(vigA,filename1,'png');
        filename2 = sprintf('vig_cameraB_3.png');
        imwrite(vigB,filename2,'png');
    elseif vig_ex_4==0
        filename1 = sprintf('vig_cameraA_4.png');
        imwrite(vigA,filename1,'png');
        filename2 = sprintf('vig_cameraB_4.png');
        imwrite(vigB,filename2,'png');
    elseif vig_ex_5==0
        filename1 = sprintf('vig_cameraA_5.png');
        imwrite(vigA,filename1,'png');
        filename2 = sprintf('vig_cameraB_5.png');
        imwrite(vigB,filename2,'png');
    else 
        display('Maximum vignette images reached, images not stored')
    end
    
end



function FrameRateText_Callback(hObject, eventdata, handles)
% hObject    handle to FrameRateText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FrameRateText as text
%        str2double(get(hObject,'String')) returns contents of FrameRateText as a double


% --- Executes during object creation, after setting all properties.
function FrameRateText_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FrameRateText (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ExposureTextB_Callback(hObject, eventdata, handles)
% hObject    handle to ExposureTextB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
get(hObject,'String');
handles.ExposureB=str2double(get(hObject,'String'));
guidata(hObject,handles);

% Hints: get(hObject,'String') returns contents of ExposureTextB as text
%        str2double(get(hObject,'String')) returns contents of ExposureTextB as a double


% --- Executes during object creation, after setting all properties.
function ExposureTextB_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ExposureTextB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ExposureTextA_Callback(hObject, eventdata, handles)
% hObject    handle to ExposureTextA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
get(hObject,'String');
handles.ExposureA=str2double(get(hObject,'String'));
guidata(hObject,handles);

% Hints: get(hObject,'String') returns contents of ExposureTextA as text
%        str2double(get(hObject,'String')) returns contents of ExposureTextA as a double


% --- Executes during object creation, after setting all properties.
function ExposureTextA_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ExposureTextA (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
